function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var reactBootstrap = require('react-bootstrap');
var PropTypes = _interopDefault(require('prop-types'));
require('bootstrap/dist/css/bootstrap.min.css');

var MyBootstrapTable = function MyBootstrapTable(_ref) {
  var className = _ref.className,
      header = _ref.header,
      tabledata = _ref.tabledata,
      _ref$pagesize = _ref.pagesize,
      pagesize = _ref$pagesize === void 0 ? 0 : _ref$pagesize,
      _ref$paginationsize = _ref.paginationsize,
      paginationsize = _ref$paginationsize === void 0 ? 5 : _ref$paginationsize;

  var _useState = React.useState([]),
      paginationItems = _useState[0],
      setPaginationItems = _useState[1];

  var _useState2 = React.useState(0),
      currentPage = _useState2[0],
      setCurrentPage = _useState2[1];

  var _useState3 = React.useState(true),
      showPagination = _useState3[0],
      setShowPagination = _useState3[1];

  var _useState4 = React.useState([]),
      tableData = _useState4[0],
      setTableData = _useState4[1];

  var _useState5 = React.useState(false),
      showPrev = _useState5[0],
      setShowPrev = _useState5[1];

  var _useState6 = React.useState(false),
      showNext = _useState6[0],
      setShowNext = _useState6[1];

  var showDataPage = function showDataPage(activePage) {
    var offset = activePage * pagesize;
    var table = pagesize === 0 ? tabledata : tabledata.slice(offset).slice(0, pagesize);
    var totalPages = Math.ceil(tabledata.length / pagesize) | 0;
    setTableData(table);
    setShowPagination(totalPages > 1);
    if (totalPages === 1) return;
    var paginationOffset = Math.floor(activePage / paginationsize);
    var paginationBtns = [].concat(Array(paginationsize).keys()).map(function (x) {
      return x + 1 + paginationOffset * paginationsize;
    });
    paginationBtns = paginationBtns.filter(function (x) {
      return x <= totalPages;
    });
    var firstItem = paginationBtns[0];
    var lastItem = paginationBtns.slice(-1)[0];
    setShowPrev(firstItem !== 1);
    setShowNext(lastItem < totalPages);
    setPaginationItems(paginationBtns);
  };

  var paginationClick = function paginationClick(e) {
    if (e.target.text === undefined) return;
    var num = parseInt(e.target.text) - 1;
    setCurrentPage(num);
    showDataPage(num);
  };

  var paginationNext = function paginationNext(e) {
    var next = (Math.floor(currentPage / paginationsize) + 1) * paginationsize;
    setCurrentPage(next);
    showDataPage(next);
  };

  var paginationPrev = function paginationPrev(e) {
    var prev = (Math.floor(currentPage / paginationsize) + 1) * paginationsize - paginationsize - 1;
    setCurrentPage(prev);
    showDataPage(prev);
  };

  React.useEffect(function () {
    showDataPage(0);
  }, [tabledata]);
  return /*#__PURE__*/React.createElement("div", {
    className: className
  }, /*#__PURE__*/React.createElement(reactBootstrap.Table, {
    responsive: true,
    striped: true,
    bordered: true,
    hover: true
  }, header ? /*#__PURE__*/React.createElement("thead", null, /*#__PURE__*/React.createElement("tr", null, " ", Object.keys(header).map(function (k, index) {
    return /*#__PURE__*/React.createElement("th", {
      key: index,
      width: header[k]['width'] ? header[k]['width'] : 'auto'
    }, header[k]['title']);
  }))) : '', /*#__PURE__*/React.createElement("tbody", null, " ", tableData.map(function (data, index) {
    return /*#__PURE__*/React.createElement("tr", {
      key: index
    }, Object.keys(data).map(function (k, index) {
      return /*#__PURE__*/React.createElement("td", {
        key: index + 1
      }, data[k].toString());
    }));
  }))), showPagination ? /*#__PURE__*/React.createElement(reactBootstrap.Pagination, null, showPrev ? /*#__PURE__*/React.createElement(reactBootstrap.Pagination.Prev, {
    onClick: paginationPrev
  }) : '', paginationItems.map(function (itemPage, index) {
    return /*#__PURE__*/React.createElement(reactBootstrap.Pagination.Item, {
      onClick: paginationClick,
      key: itemPage,
      active: currentPage === itemPage - 1
    }, itemPage);
  }), showNext ? /*#__PURE__*/React.createElement(reactBootstrap.Pagination.Next, {
    onClick: paginationNext
  }) : '') : '');
};

MyBootstrapTable.propTypes = {
  'className': PropTypes.string,
  'header': PropTypes.object,
  'pagesize': PropTypes.number,
  'paginationsize': PropTypes.number,
  'tabledata': PropTypes.array.isRequired
};

module.exports = MyBootstrapTable;
//# sourceMappingURL=index.js.map
